diff --git a/libavcodec/qsvenc.c b/libavcodec/qsvenc.c
index 53377fbf26..b15434d4a4 100644
--- a/libavcodec/qsvenc.c
+++ b/libavcodec/qsvenc.c
@@ -1132,6 +1132,7 @@ int ff_qsv_enc_init(AVCodecContext *avctx, QSVEncContext *q)
     if (!iopattern)
         iopattern = MFX_IOPATTERN_IN_SYSTEM_MEMORY;
     q->param.IOPattern = iopattern;
+    qsv_print_iopattern(avctx, iopattern, "Encoder");
 
     ret = qsvenc_init_session(avctx, q);
     if (ret < 0)
diff --git a/libavfilter/qsvvpp.c b/libavfilter/qsvvpp.c
index 8d5ff2eb65..1cfad4c445 100644
--- a/libavfilter/qsvvpp.c
+++ b/libavfilter/qsvvpp.c
@@ -505,15 +505,19 @@ static int init_vpp_session(AVFilterContext *avctx, QSVVPPContext *s)
         }
     }
 
-    if (ret != MFX_ERR_NONE) {
-        av_log(avctx, AV_LOG_ERROR, "Error getting the session handle\n");
+    if (ret < 0)
+        return qsv_print_error(avctx, ret, "Error getting the session handle");
+    else if (ret > 0) {
+        qsv_print_warning(avctx, ret, "Warning in getting the session handle");
         return AVERROR_UNKNOWN;
     }
 
     /* create a "slave" session with those same properties, to be used for vpp */
     ret = MFXInit(impl, &ver, &s->session);
-    if (ret != MFX_ERR_NONE) {
-        av_log(avctx, AV_LOG_ERROR, "Error initializing a session for scaling\n");
+    if (ret < 0)
+        return qsv_print_error(avctx, ret, "Error initializing a session");
+    else if (ret > 0) {
+        qsv_print_warning(avctx, ret, "Warning in session initialization");
         return AVERROR_UNKNOWN;
     }
 
@@ -646,11 +650,16 @@ int ff_qsvvpp_create(AVFilterContext *avctx, QSVVPPContext **vpp, QSVVPPParam *p
     else if (IS_OPAQUE_MEMORY(s->out_mem_mode))
         s->vpp_param.IOPattern |= MFX_IOPATTERN_OUT_OPAQUE_MEMORY;
 
+    /* Print input memory mode */
+    qsv_print_iopattern(avctx, s->vpp_param.IOPattern & 0x0F, "VPP");
+    /* Print output memory mode */
+    qsv_print_iopattern(avctx, s->vpp_param.IOPattern & 0xF0, "VPP");
     ret = MFXVideoVPP_Init(s->session, &s->vpp_param);
     if (ret < 0) {
-        av_log(avctx, AV_LOG_ERROR, "Failed to create a qsvvpp, ret = %d.\n", ret);
+        ret = qsv_print_error(avctx, ret, "Failed to create a qsvvpp");
         goto failed;
-    }
+    } else if (ret > 0)
+        qsv_print_warning(avctx, ret, "Warning When creating qsvvpp");
 
     *vpp = s;
     return 0;
diff --git a/libavfilter/qsvvpp.h b/libavfilter/qsvvpp.h
index c2bcce7548..da4ed56ce4 100644
--- a/libavfilter/qsvvpp.h
+++ b/libavfilter/qsvvpp.h
@@ -24,21 +24,13 @@
 #ifndef AVFILTER_QSVVPP_H
 #define AVFILTER_QSVVPP_H
 
-#include <mfx/mfxvideo.h>
+#include "libavcodec/qsv_core_internal.h"
 
 #include "avfilter.h"
 
 #define FF_INLINK_IDX(link)  ((int)((link)->dstpad - (link)->dst->input_pads))
 #define FF_OUTLINK_IDX(link) ((int)((link)->srcpad - (link)->src->output_pads))
 
-#define QSV_VERSION_ATLEAST(MAJOR, MINOR)   \
-    (MFX_VERSION_MAJOR > (MAJOR) ||         \
-     MFX_VERSION_MAJOR == (MAJOR) && MFX_VERSION_MINOR >= (MINOR))
-
-#define QSV_RUNTIME_VERSION_ATLEAST(MFX_VERSION, MAJOR, MINOR) \
-    ((MFX_VERSION.Major > (MAJOR)) ||                           \
-    (MFX_VERSION.Major == (MAJOR) && MFX_VERSION.Minor >= (MINOR)))
-
 typedef struct QSVVPPContext QSVVPPContext;
 
 typedef struct QSVVPPCrop {
diff --git a/libavfilter/vf_deinterlace_qsv.c b/libavfilter/vf_deinterlace_qsv.c
index 80217c8419..30d1bed526 100644
--- a/libavfilter/vf_deinterlace_qsv.c
+++ b/libavfilter/vf_deinterlace_qsv.c
@@ -202,16 +202,20 @@ static int init_out_session(AVFilterContext *ctx)
         }
     }
 
-    if (err != MFX_ERR_NONE) {
-        av_log(ctx, AV_LOG_ERROR, "Error getting the session handle\n");
+    if (err < 0)
+        return qsv_print_error(ctx, err, "Error getting the session handle");
+    else if (err > 0) {
+        qsv_print_warning(ctx, err, "Warning in getting the session handle");
         return AVERROR_UNKNOWN;
     }
 
     /* create a "slave" session with those same properties, to be used for
      * actual deinterlacing */
     err = MFXInit(impl, &ver, &s->session);
-    if (err != MFX_ERR_NONE) {
-        av_log(ctx, AV_LOG_ERROR, "Error initializing a session for deinterlacing\n");
+    if (err < 0)
+        return qsv_print_error(ctx, err, "Error initializing a session for deinterlacing");
+    else if (err > 0) {
+        qsv_print_warning(ctx, err, "Warning in session initialization");
         return AVERROR_UNKNOWN;
     }
 
@@ -309,9 +313,17 @@ static int init_out_session(AVFilterContext *ctx)
         par.vpp.Out.FrameRateExtD = ctx->outputs[0]->time_base.den;
     }
 
+    /* Print input memory mode */
+    qsv_print_iopattern(ctx, par.IOPattern & 0x0F, "VPP");
+    /* Print output memory mode */
+    qsv_print_iopattern(ctx, par.IOPattern & 0xF0, "VPP");
     err = MFXVideoVPP_Init(s->session, &par);
-    if (err != MFX_ERR_NONE) {
-        av_log(ctx, AV_LOG_ERROR, "Error opening the VPP for deinterlacing: %d\n", err);
+    if (err < 0)
+        return qsv_print_error(ctx, err,
+                               "Error opening the VPP for deinterlacing");
+    else if (err > 0) {
+        qsv_print_warning(ctx, err,
+                          "Warning in VPP initialization");
         return AVERROR_UNKNOWN;
     }
 
@@ -482,8 +494,13 @@ static int process_frame(AVFilterContext *ctx, const AVFrame *in,
         return QSVDEINT_MORE_INPUT;
     }
 
-    if ((err < 0 && err != MFX_ERR_MORE_SURFACE) || !sync) {
-        av_log(ctx, AV_LOG_ERROR, "Error during deinterlacing: %d\n", err);
+    if (err < 0 && err != MFX_ERR_MORE_SURFACE) {
+        ret = qsv_print_error(ctx, err, "Error during deinterlacing");
+        goto fail;
+    }
+
+    if (!sync) {
+        av_log(ctx, AV_LOG_ERROR, "No sync during deinterlacing\n");
         ret = AVERROR_UNKNOWN;
         goto fail;
     }
@@ -494,8 +511,7 @@ static int process_frame(AVFilterContext *ctx, const AVFrame *in,
         err = MFXVideoCORE_SyncOperation(s->session, sync, 1000);
     } while (err == MFX_WRN_IN_EXECUTION);
     if (err < 0) {
-        av_log(ctx, AV_LOG_ERROR, "Error synchronizing the operation: %d\n", err);
-        ret = AVERROR_UNKNOWN;
+        ret = qsv_print_error(ctx, err, "Error synchronizing the operation");
         goto fail;
     }
 
diff --git a/libavfilter/vf_scale_qsv.c b/libavfilter/vf_scale_qsv.c
index 5064dcbb60..9a423081c2 100644
--- a/libavfilter/vf_scale_qsv.c
+++ b/libavfilter/vf_scale_qsv.c
@@ -313,8 +313,10 @@ static int init_out_session(AVFilterContext *ctx)
         }
     }
 
-    if (err != MFX_ERR_NONE) {
-        av_log(ctx, AV_LOG_ERROR, "Error getting the session handle\n");
+    if (err < 0)
+        return qsv_print_error(ctx, err, "Error getting the session handle");
+    else if (err > 0) {
+        qsv_print_warning(ctx, err, "Warning in getting the session handle");
         return AVERROR_UNKNOWN;
     }
 
@@ -430,9 +432,17 @@ static int init_out_session(AVFilterContext *ctx)
     par.vpp.Out.FrameRateExtN = 25;
     par.vpp.Out.FrameRateExtD = 1;
 
+    /* Print input memory mode */
+    qsv_print_iopattern(ctx, par.IOPattern & 0x0F, "VPP");
+    /* Print output memory mode */
+    qsv_print_iopattern(ctx, par.IOPattern & 0xF0, "VPP");
     err = MFXVideoVPP_Init(s->session, &par);
-    if (err != MFX_ERR_NONE) {
-        av_log(ctx, AV_LOG_ERROR, "Error opening the VPP for scaling\n");
+    if (err < 0)
+        return qsv_print_error(ctx, err,
+                               "Error opening the VPP for scaling");
+    else if (err > 0) {
+        qsv_print_warning(ctx, err,
+                          "Warning in VPP initialization");
         return AVERROR_UNKNOWN;
     }
 
@@ -573,8 +583,13 @@ static int qsvscale_filter_frame(AVFilterLink *link, AVFrame *in)
             av_usleep(1);
     } while (err == MFX_WRN_DEVICE_BUSY);
 
-    if (err < 0 || !sync) {
-        av_log(ctx, AV_LOG_ERROR, "Error during scaling\n");
+    if (err < 0) {
+        ret = qsv_print_error(ctx, err, "Error during scaling");
+        goto fail;
+    }
+
+    if (!sync) {
+        av_log(ctx, AV_LOG_ERROR, "No sync during scaling\n");
         ret = AVERROR_UNKNOWN;
         goto fail;
     }
@@ -583,8 +598,7 @@ static int qsvscale_filter_frame(AVFilterLink *link, AVFrame *in)
         err = MFXVideoCORE_SyncOperation(s->session, sync, 1000);
     } while (err == MFX_WRN_IN_EXECUTION);
     if (err < 0) {
-        av_log(ctx, AV_LOG_ERROR, "Error synchronizing the operation: %d\n", err);
-        ret = AVERROR_UNKNOWN;
+        ret = qsv_print_error(ctx, err, "Error synchronizing the operation");
         goto fail;
     }
 